<?php

/*
 * Template variables:
 *  fixedEmail - NULL|string - if a string, email field is locked to this one. FB/Twitter registration is disallowed.
 *  registrationErrors - NULL|string - errors to display
 *  email, username - NULL|string - data for the form
 *  brandName - NULL|string - if nonempty, displayed as the brand name
 *  createAnotherBrand - true if the user already has a brand
 */

use LabBase\Model\User;


if($this->createAnotherBrand) {
    //$firstStepId = "confirmBrand";
    $firstStepId = 'selectProfileType';
}elseif($this->confirmBrand) {
    $firstStepId = "email"; // auto animated on load
}elseif($this->registrationErrors || $this->fixedEmail) {
    $firstStepId = "email"; // email registration
}else{
    $firstStepId = "1"; // default (fb/twitter selection)
}

$username = $email = '';

if($this->username)
    $username = $this->username;
if($this->email)
    $email = $this->email;

$brandName = $this->brandName;

function animStep($stepId, $firstStepId) {

    if($stepId == $firstStepId) {
        return 'anim-step-'.$stepId.' first-anim-step';
    }
    return 'anim-step-'.$stepId.' hidden';
}


?>



<div class="node" style="overflow: hidden">

    <div id="numbertag-panel">
        <span class="numbertag-container" style="width: 205px;">
            <img src="<?= $this->basePath() ?>/img/tagarrow.png" />
            <span class="numbertag">1</span>
            <span class="tag-label">Register your Brand</span>
        </span>

        <span class="active numbertag-container" style="width: 220px;">
            <img src="<?= $this->basePath() ?>/img/tagarrow-active.png" />
            <span class="active numbertag">2</span>
            <span class="tag-label">Create an account</span>
        </span>

        <span class="numbertag-container" style="width:100px">
            <img src="<?= $this->basePath() ?>/img/tagarrow.png" />
            <span class="numbertag">3</span>
            <span class="tag-label">Finish</span>
        </span>
    </div>

    <div class="align-center" style="padding-top: 1px">
        <h1>Get started with Love a Brand</h1>
        <h2><small id="registerSlogan">It's free, fast and secure</small></h2>
    </div>


    <div class="anim-container" style="position: relative; width: 100%; max-width: 800px; height: 1px;">

        <div class="<?= animStep("1", $firstStepId) ?>" style="position: absolute; left: 0; top: 0">
            <div class="align-center">

                <div style="text-align: center">

                    <?php 
                        $socialSignIn = true;
                        foreach ($this->options->getEnabledProviders() as $provider) {
                            if ($socialSignIn) {
                                $socialSignIn = false;
                            }
                            
                            $logoURL = $this->basePath()."/img/{$provider}.png";
                            
                            echo $this->socialSignInButton($provider, $this->redirect, $logoURL);
                        }
                    ?>
                
                    <!--<a href="#">
                        <div class="margin-center register-button facebook" onclick="loginFB(); animateToId('loading'); return false;">
                            <img src="<?= $this->basePath() ?>/img/register-1.png" alt="Register with Facebook" title="Register with Facebook" />
                        </div>
                    </a>

                    <a href="#">
                        <div class="margin-center register-button twitter" onclick="animateToId('loading'); return false;">
                            <img src="<?= $this->basePath() ?>/img/register-2.png" alt="Register with Twitter" title="Register with Twitter" />
                        </div>
                    </a>-->

                    <div style="margin-top: 4px; ">
                        <small>
                            Or sign up with an <a href="#" onclick="animateToId('email'); return false;">email account</a>
                        </small>
                    </div>

                </div>
            </div>
        </div>

        <div class="form-container <?= animStep("email", $firstStepId) ?>" style="position: absolute; top: 0">
            <div class="">
                <form id="form" action="<?= $this->url('root/register')?>" onsubmit="return validateRegisterForm();" method="post">

                    <p id="registererrorcontainer" style="color: red; line-height: 115%;">
                        <?= $this->registrationErrors; ?>
                    </p>

                    <input class="textbox" type="text" onkeydown="$(this).removeClass('error');" name="username" id="username" value="<?= $username ?>" placeholder="Username" /><br />

                    <input class="textbox" type="text" onkeydown="$(this).removeClass('error');" name="email" id="email" value="<?= $email ?>" placeholder="Email address" /><br />

                    <input class="textbox"  type="password" onkeydown="$(this).removeClass('error');" name="password" id="password" placeholder="Password" /><br />

                    <input type="submit" style="margin-top: 20px" class="float-right" value="Sign me up" />
                </form>
            </div>

            <? if(!$this->fixedEmail) { // disallow fb/twitter ?>
            <small id="backTo1">Register using <a href="#" onclick="animateToId('1'); return false;">facebook or twitter</a></small>
            <? } ?>
        </div>

        <script>
            function validateRegisterBrandSubmit() {
                if($('#brandTypeHidden').val().length < 1) {
                    animateToId('selectProfileType');
                    return false;
                }
                if($('#brandNameInput').val().length < 1) {
                    return false;
                }
                return true;
            }
            function setProfileType(brandType) {
                $('#brandTypeHidden').val(brandType);
                switch (brandType) {
                    case "brand":
                        $('#brandInputHint').text('Please make sure that your brand name is spelt correctly');
                        $('#createProfileSubmit').attr('value', 'Create brand page');
                        break;
                    case "pro":
                        $('#brandInputHint').text('Please make sure that your profile name is spelt correctly');
                        $('#createProfileSubmit').attr('value', 'Create my profile');
                        break;
                    case "custom":
                        $('#brandInputHint').text('Please make sure that the name of your profile is spelt correctly');
                        $('#createProfileSubmit').attr('value', 'Create my profile');
                        break;
                }
                animateToId('confirmBrand');
            }
        </script>

        <div class="form-container <?= animStep("confirmBrand", $firstStepId) ?>" style="position: absolute; top: 0">
            <div class="">
                <form id="registerForm" action="<?= $this->url('root/register') ?>" onsubmit="return validateRegisterBrandSubmit()" method="post">

                    <label id="brandInputHint">Please make sure that your profile name is spelt correctly</label>

                    <input type="text" id="brandNameInput" class="textbox" name="brandName" placeholder="Enter your name"  /><br />
                    <input type="hidden" name="brandRegistration" value="true" />
                    <input type="hidden" id="brandTypeHidden" name="brandType" value="" />
                    <p id="registererrorcontainer" style="color: red; line-height: 115%;">
                        <?= $this->registrationErrors; ?>
                    </p>

                    <div style="margin-top: 4px; ">
                        <small>
                            <a href="#" onclick="animateToId('selectProfileType'); return false;">Change profile type</a>
                        </small>
                    </div>

                    <input id="createProfileSubmit" type="submit" style="margin-top: 10px" class="float-right" value="Create profile page" />

                </form>
            </div>
        </div>

        <div class="form-container fullwidth <?= animStep("selectProfileType", $firstStepId) ?>" style="position: absolute; top: 0">
            <div class="profileSelectContainer">

                    <div class="profile">
                        <img src="<?= $this->imageLinker()->getImageLinkFromId('system-profileselect-brand') ?>" />
                        <div class="alignWrapper">
                            <h1>Are you a Brand?</h1>
                            <p>People are looking for businesses like yours online.</p>
                        </div>
                        <div class="align-center"><a href="#" class="lab-button" onclick="setProfileType('brand'); return false;">Get started now</a></div>
                    </div>
                    <div class="profile">
                        <img src="<?= $this->imageLinker()->getImageLinkFromId('system-profileselect-pro') ?>" />
                        <div class="alignWrapper">
                            <h1>Are you a Professional or Student?</h1>
                            <p>Build your profile with a bio or portfolio.</p>
                        </div>
                        <div class="align-center"><a href="#" class="lab-button" onclick="setProfileType('pro'); return false;">Get started now</a></div>
                    </div>
                    <div class="profile">
                        <img src="<?= $this->imageLinker()->getImageLinkFromId('system-profileselect-custom') ?>" />
                        <div class="alignWrapper">
                            <h1>Build it your own way</h1>
                            <p>Customise your profile the way you'd like.</p>
                        </div>
                        <div class="align-center"><a href="#" class="lab-button" onclick="setProfileType('custom'); return false;">Get started now</a></div>
                    </div>

            </div>

        </div>

        <div class="form-container <?= animStep("alreadyRegistered", $firstStepId) ?>" style="position: absolute; top: 0">
            <div>
                <p style="line-height: 115%;">
                    <? /* todo: fix this error message */ ?>
                    It appears that you have already registered. To register a brand, please go to your profile settings.
                </p>
            </div>
        </div>

        <div class="anim-no-slide <?= animStep("loading", $firstStepId) ?>" style="position: absolute; top: 0">
            <img class="margin-center" style="width: 128px; height: 128px; margin-top: 20px" src="<?= $this->basePath(); ?>/img/loading.gif" alt="Loading..."
                 onclick="animateToId('1'); return false;" />
        </div>


    </div>
    <div class="anim-container-heightfix" style="height: 100px;margin-bottom: 100px;"></div>


</div>


<script>
    var firstStep = $(".first-anim-step");
    var current_step = firstStep;
    var numbertag_panel = $("#numbertag-panel");
    var numbertag_containers = $(".numbertag-container");
    var node = $(".node");
    var anim_container = $(".anim-container");

    var is_animating = false;

    $(function() {
        // on load
        // fill the brand name from the cookies
        <? if(!empty($brandName)) { ?>
            $("#brandNameInput").val('<?= $brandName ?>');
        <? }else{ ?>
            var foundCookie = document.cookie.match(/brandName=([^;]*)/);
            if(foundCookie && foundCookie.length > 1) {
                var brandName = decodeURIComponent(foundCookie[1]);
                $("#brandNameInput").val(brandName);
            }
        <? } ?>

        <? if($this->confirmBrand) { ?>
            // wait for the page to load for smooth animation
            // 300ms delay was a bit jumpy on slower devices
            window.setTimeout(function(){animateToId('selectProfileType');}, 400);
        <? }else{
            // We're not confirming the first brand, is the user already registered?
            /**
            * @var User $user
            */
            $user = $this->sessionInfo()->getLoggedInUser();
            if($user) { // are we logged in?
                // todo
            }
        } ?>
    });

    function animateToId(id) {

        if(is_animating) {
            window.setTimeout(function() { animateToId(id); }, 100);
            return; // already animating
        }

        $('#registerSlogan').css('opacity', id=='selectProfileType'?0:1);

        var target_step = $(".anim-step-" + id);
        if(target_step[0] == current_step[0])
            return;

        var trackedPages = {
            '1': 'RegistrationStart',
            'email': 'EmailRegistration',
            'confirmBrand': 'BrandNameConfirmation',
            'alreadyRegistered': 'BrandAlreadyRegisteredError'
        };
        if(trackedPages[id]) {
            ga('send', 'pageview', getPageAnalURL() + '#' + trackedPages[id])
        }

        current_step.css({left: 0});

        var args;
        var no_slide = current_step.hasClass("anim-no-slide");
        if (no_slide)
            args = {opacity: 0};
        else
            args = {left: "-850px", opacity: 0};

        is_animating = true;
        current_step.animate(args, no_slide ? 100 : 600, null, function () {
            $(this).addClass("hidden");
        });


        if (target_step.hasClass("anim-no-slide")) {
            args = {opacity: 1};
            target_step.css({opacity: 0}).delay(300); // delay no-slide elements
        } else {
            args = {left: "0px", opacity: 1};
            target_step.css({opacity: 0, left: "850px"});
        }

        // Steps other than 1 will have hidden class at first
        target_step.removeClass("hidden");
        target_step.animate(args, 400);

        $(".anim-container-heightfix").animate({height: target_step.height() + "px"}, target_step.height() > current_step.height() ? 300 : 500);
        anim_container.animate({marginLeft: (node.width()/2-target_step.width()/2) + "px"}, 400);


        current_step = target_step;

        var to = window.setTimeout(function() {
            is_animating = false;
        }, 600);
    }

    function validateRegisterForm(successCallback) {
        var $username = $('#username');
        var $email = $('#email');
        var $password = $('#password');
        var username = $username.val();
        var email = $email.val();
        var password = $password.val();

        var usernameError, emailError, passwordError;

        if(username.length < 2 || username.length > 120) { usernameError = "Name must be between 2 and 120 characters long."; }
        if(email.length < 5 || email.length > 120) { emailError = "Email must be between 5 and 120 characters long."; }

        if(!/^[^\s@]+@[^\s@]+\.[^\s@]+$/.test(email)) { emailError = "Given email is not valid. Please re-check the entered address."; }
        if(/[\s]/i.test(email)) { emailError = "Email address cannot contain spaces. Please re-check the entered address."; }

        if(password.length < 7 || password.length > 50) { passwordError = "Password must be between 7 and 50 characters long."; }

        if(!passwordError && /[\s]/.test(password)) { passwordError = "Password cannot contain spaces."; }

        if(!username) { usernameError = "Please enter your name."; }
        if(!email) { emailError = "Please enter your email."; }
        if(!password) { passwordError = "Please enter a password."; }

        if(!passwordError) {
            var contains_lowercase = /[a-z]/.test(password) ? 1 : 0;
            var contains_uppercase = /[A-Z]/.test(password) ? 1 : 0;
            var contains_numbers   = /[0-9]/.test(password) ? 1 : 0;
            var contains_special   = /[^a-zA-Z0-9]/.test(password) ? 1 : 0;

            if(contains_lowercase + contains_numbers + contains_uppercase + contains_special < 2) {
                passwordError = "Password must be made up of at least two of the following: Uppercase letters, lowercase letters, numbers or special characters (?!.*)";
            }
        }

        var errors = "";

        if(usernameError)
            $username.addClass("error");
        else
            $username.removeClass("error");

        if(emailError)
            $email.addClass("error");
        else
            $email.removeClass("error");

        if(passwordError)
            $password.addClass("error");
        else
            $password.removeClass("error");

        if(!passwordError && !usernameError && !emailError) {
            if(successCallback) successCallback();
        }else{
            if(usernameError)   { if(errors != "") errors += "<br />"; errors += "* " + usernameError; }
            if(emailError)      { if(errors != "") errors += "<br />"; errors += "* " + emailError; }
            if(passwordError)   { if(errors != "") errors += "<br />"; errors += "* " + passwordError; }
        }

        $("#registererrorcontainer").html(errors);

        return !passwordError && !usernameError && !emailError;
    }

    function loginFB() {
        FB.login(function(response) {
            if (response.status === 'connected' && response.authResponse) {
                FB.api('/me?scope=email', function(response) {
                    $('#username').val(response.name);
                    $('#email').val(response.email);
                    $('#password').focus();
                    $('#backTo1').hide();
                    animateToId("email");
                });
            }else {
                // todo: proper error message
                labAlert("An error has occurred when logging in, please try again or register using email.");
                animateToId("1");
            }
        }, {scope: 'email'});
    }


    var resizeFunc = function() {
        anim_container.show();

        if(node.width() < 635) {
            numbertag_containers.css({marginRight: "100px"});
            numbertag_panel.css({width: "350px"});
        }else{
            numbertag_containers.css({marginRight: 0});
            numbertag_panel.css({width: "auto"});
        }

        $(".anim-container-heightfix").css({height: current_step.height()+"px"});
        anim_container.css({marginLeft: (node.width()/2-current_step.width()/2) + "px"});

    };

    // Initially hide the container to avoid page spazzing
    // Do it at the end of JS in case it errors out
    anim_container.hide();

    $(document).ready(function() {
        resizeFunc();
        window.setTimeout(resizeFunc, 200);
        <? if($firstStepId == 'selectProfileType') { ?>
        $('#registerSlogan').css('opacity', 0);
        $('#registerSlogan').css('visibility', 'hidden');
        window.setTimeout(function() {
            $('#registerSlogan').css('visibility', 'visible');
        }, 500);
        <? } ?>
    });

    $(window).resize(resizeFunc);


</script>